﻿//////////////////////////////////////////////
// ContentLoader.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkExport
{
	class Exportable ;
	class Node ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../Dll/DllDefines.h"

#include "ContentLoadResult.h"

// nkExport
#include <NilkinsExport/Exporter/ExporterLoadResult.h>

/// Class ------------------------------------

namespace nkAstraeus
{
	class DLL_ASTRAEUS_EXPORT ContentLoader final
	{
		private :

			ContentLoader () = delete ;
			~ContentLoader () = delete ;

		public :

			// Functions from nkGraphics originally
			// Could be nice to push into nkExport (TODO)
			// Practical functions
			static nkExport::ExporterLoadResult inputData (const nkMemory::StringView& filePath) ;
			static nkMemory::String inputDataStr (const nkMemory::StringView& filePath) ;
			static nkExport::ExporterLoadResult inputDataSources (const nkMemory::StringView& sources) ;
			static bool outputData (const nkMemory::StringView& content, const nkMemory::StringView& path) ;

			// Save
			static bool saveTreeDeclaration (nkExport::Node* tree, const nkMemory::StringView& pathFromData) ;
			static bool saveObjectDeclaration (nkExport::Exportable* object, const nkMemory::StringView& pathFromData) ;

			// Materials
			static ContentLoadResultMaterial loadMaterialDeclaration (const nkMemory::StringView& pathFromData, bool loadResource = true) ;
			static ContentLoadResultMaterial processMaterialSources (const nkMemory::StringView& sources, bool loadResource = true) ;
			static ContentLoadResultMaterial processMaterialTree (nkExport::Node* tree, bool loadResource = true) ;
	} ;
}