﻿//////////////////////////////////////////////
// PbsProgramTracker.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Program ;
}

/// Includes ---------------------------------

// nkAstraeus
#include "../../Utils/ProgramTracker.h"

#include "PbsMaterialInfo.h"

// nkCommon
#include <nilkinsCommon/Patterns/SingletonClass.h>

// Standards
#include <unordered_map>

/// Internals --------------------------------

namespace nkAstraeus
{
	struct PbsProgramIdGenerator
	{
		static unsigned long long generate (const PbsMaterialInfo& info) ;
	} ;

	struct PbsProgramNameGenerator
	{
		constexpr static const char* name = "NILKINS_PBS_PROGRAM_" ;
	} ;
}

/// Class ------------------------------------

namespace nkAstraeus
{
	class PbsProgramTracker final : public ProgramTracker<PbsMaterialInfo, PbsProgramIdGenerator, PbsProgramNameGenerator>, public nkCommon::SingletonClass<PbsProgramTracker>
	{
		friend class SingletonClass<PbsProgramTracker> ;

		private :

			// Functions
			// Constructor, destructor
			PbsProgramTracker () ;
			~PbsProgramTracker () ;
	} ;
}