﻿//////////////////////////////////////////////
// Color.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"

/// Class ------------------------------------

namespace nkWinUi
{
	class DLL_WINUI_EXPORT Color final
	{
		private :

			float _r ;
			float _g ;
			float _b ;
			float _a ;

		public :

			// Constructor, destructor
			Color () ;
			explicit Color (unsigned char r, unsigned char g, unsigned char b, unsigned char a = 255) ;
			explicit Color (float r, float g, float b, float a = 1.f) ;
			explicit Color (double r, double g, double b, double a = 1.0) ;
			explicit Color (unsigned int r, unsigned int g, unsigned int b, unsigned int a = 255u) ;
			explicit Color (unsigned long long r, unsigned long long g, unsigned long long b, unsigned long long a = 255ull) ;
			explicit Color (int r, int g, int b, int a = 255) ;
			explicit Color (long long r, long long g, long long b, long long a = 255ll) ;
			~Color () ;

			// Getters
			float getR () const ;
			float getG () const ;
			float getB () const ;
			float getA () const ;
			unsigned int getR255 () const ;
			unsigned int getG255 () const ;
			unsigned int getB255 () const ;
			unsigned int getA255 () const ;

			// Manipulations couleurs
			// Multiplie par le facteur donné si la luminosité n'est pas trop grande
			Color getAssociateColor (float factor = 1.5f) const ;
			// Mix par un facteur avec une autre couleur
			Color mix (const Color& other, float factor) const ;
			// Eclaircissement par layering
			Color getColorForDepth (unsigned int depth) const ;

			// Surcharges opérateurs
			Color operator* (float factor) const ;
	} ;
}
/*
//////////////////////////////////////////////
// Color.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkWinUi
#include "../Dll/DllDefines.h"

/// Class ------------------------------------

namespace nkWinUi
{
class DLL_WINUI_EXPORT Color final
{
private :

float _r ;
float _g ;
float _b ;
float _a ;

public :

// Constructor, destructor
Color () ;
Color (unsigned char r, unsigned char g, unsigned char b, unsigned char a) ;
Color (float r, float g, float b, float a) ;
~Color () ;

// Manipulations couleurs
// Multiplie par le facteur donné si la luminosité n'est pas trop grande
Color getAssociateColor (float factor = 1.5f) const ;
// Mix par un facteur avec une autre couleur
Color mix (const Color& other, float factor) const ;
// Eclaircissement par layering
Color getColorForDepth (unsigned int depth) const ;

// Surcharges opérateurs
Color operator* (float factor) const ;
} ;
}*/